/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : back_wb.cc
Last edit : 10/20/92
Created   :
Version   : 1.12

History   :

Does      :
*/
#include <stdlib.h>
#include <curses.h>
#include <string.h>

#include <paths.h>
#include <mcform.h>
#include <ruutu.h>
#include <limits.h>

#include "../race/race_main.h"
#include "back_menu.h"
#include "item.h"
#include "special.h"

extern int fetch_stats(char *);
extern int back_stat(int);
extern int misc_s_bonus(int,int);
extern void save_background(char *, struct item*, struct special*, int,int, int);

extern "C" {
  void put_back_logo(void);
  struct back_menu *put_back_menu(struct back_menu*);
  int rahat(void);
  char *items(void);
  char *skarms(int *,int *);
  char *disadv(void);
  char *skmagi(int *,int *);
  char *spac(void);
  char *mstrtok(char *, char*);
};

void do_background(char *arg)
{
  struct back_menu points;
  int m;
  int ok=0;
  int gold = 0;
  struct item *n=NULL;
  struct item *l=NULL;
  struct item *y=NULL;
  struct special *ns=NULL;
  struct special *ls=NULL;
  struct special *ys=NULL;
  char *t;
  int statti=0;
  int bonus =0;
  int randoms=0;
  int lang=0;
  
  points.bag = fetch_stats(arg);  
  printw(" ");
  refresh();
  clear();
  refresh();
  while(!ok) {
    put_back_menu(&points);
    m = getch();
    switch(m) {
      case 'o':		// Raise one stat with two
	if(!points.bag)
	  break;
	points.bag -= (back_stat(1) ? 0 : 1);
	clear();
	break;
      case 't':		// Raise three stats with one
	if(!points.bag)
	  break;
	points.bag -= (back_stat(3) ? 0: 1);
	clear();
	break;
      case 'm':		// Roll from money table
	if(!points.bag)
	  break;
        gold += rahat();
	points.bag--;
	break;
      case 'i':		// Roll from item table
	if(!points.bag)
	  break;
	n = (struct item*)calloc(1,sizeof(struct item));
        if(!n) {
	  perror("back_wb.cc/calloc()");
          exit(0);
        }
        if(!l)
	  l = n;
	if(!y)
	  y = n;
	else {
	  y->next = n;
	  y = n;
	};
	n->next = NULL;
	sprintf(n->name,"%s",items());
	points.bag--;
	break;
      case 'a':		// Roll from skill at arms
	if(!points.bag)
	  break;
	t = skarms(&statti, &bonus);
	if(t) {
	  ns = (struct special *)calloc(1, sizeof(struct special));
	  if(!ns) {
	    perror("calloc()");
	    exit(0);
          }
 	  if(!ls)
	    ls = ns;
	  if(!ys) 
	    ys = ns;
	  else {
	    ys->next = ns;
	    ys = ns;
	  }
	  sprintf(ns->name,"%s",t);
	  ns->next = NULL;
        }
	else 
	  misc_s_bonus(statti,bonus);
	points.bag--;
	break;
      case 'g':		// Roll from skill at magic
	if(!points.bag)
	  break;
	t = skmagi(&statti, &bonus);
	if(t) {
	  ns = (struct special *)calloc(1, sizeof(struct special));
	  if(!ns) {
	    perror("calloc()");
	    exit(0);
          }
 	  if(!ls)
	    ls = ns;
	  if(!ys) 
	    ys = ns;
	  else {
	    ys->next = ns;
	    ys = ns;
	  }
	  sprintf(ns->name,"%s",t);
	  ns->next = NULL;
        }
	else 
	  misc_s_bonus(statti,bonus);
	points.bag--;
	break;
	break;
      case 's':		// Secondary skill +15 bonus
	if(!points.bag)
	  break;

        ns = (struct special *)calloc(1, sizeof(struct special));
        if(!ns) {
	  perror("calloc()");
	  exit(0);
        }
 	if(!ls)
	  ls = ns;
	if(!ys) 
	  ys = ns;
	else {
	  ys->next = ns;
	  ys = ns;
	}
	sprintf(ns->name,"secondary +15 bonus");
	ns->next = NULL;
  	move(20,0);
	printw("You've got a +15 secondary skill bonus. Press any key to continue.");
	refresh();
	getch();
	move(20,0);
	clrtoeol();
	refresh();
        points.bag--;
	break;
      case 'p':		// Primary skill +10 bonus
	if(!points.bag)
	  break;

        ns = (struct special *)calloc(1, sizeof(struct special));
        if(!ns) {
	  perror("calloc()");
	  exit(0);
        }
 	if(!ls)
	  ls = ns;
	if(!ys) 
	  ys = ns;
	else {
	  ys->next = ns;
	  ys = ns;
	}
	sprintf(ns->name,"primary +10 bonus");
	ns->next = NULL;
  	move(20,0);
	printw("You've got a +10 primary skill bonus. Press any key to continue.");
	refresh();
	getch();
	move(20,0);
	clrtoeol();
	refresh();
        points.bag--;
	break;
	break;
      case 'e':		// A +1 adder
	if(!points.bag)
	  break;

        n = (struct item *)calloc(1, sizeof(struct item));
        if(!n) {
	  perror("calloc()");
	  exit(0);
        }
 	if(!l)
	  l = n;
	if(!y) 
	  y = n;
	else {
	  y->next = n;
	  y = n;
	}
	sprintf(n->name,"+1 adder");
	n->next = NULL;
  	move(20,0);
	printw("You've got a +1 adder. Press any key to continue.");
	refresh();
	getch();
	move(20,0);
	clrtoeol();
	refresh();
        points.bag--;
	break;
	break;
      case 'l':		// 6 ranks in one language
	if(!points.bag)
	  break;
  	move(20,0);
	printw("You've learned 6 ranks. Press any key to continue.");
	refresh();
	getch();
	move(20,0);
	clrtoeol();
	refresh();
        lang++;
        points.bag--;
	break;
	break;
      case 'r':		// 5 ranks in random skill
	if(!points.bag)
	  break;
  	move(20,0);
	printw("You've learned 5 ranks in random skill. Press any key to continue.");
	refresh();
	getch();
	move(20,0);
	clrtoeol();
	refresh();
        randoms++;
        points.bag--;
	break;
      case 'd':		// A disadvantage
	t = disadv();
	if(t) {
	  ns = (struct special *)calloc(1, sizeof(struct special));
	  if(!ns) {
	    perror("calloc()");
	    exit(0);
          }
 	  if(!ls)
	    ls = ns;
	  if(!ys) 
	    ys = ns;
	  else {
	    ys->next = ns;
	    ys = ns;
	  }
	  sprintf(ns->name,"%s",t);
	  ns->next = NULL;
        }
        points.bag++;
	break;
      case 'c':		// Special ability
	if(!points.bag)
	  break;
	t = spac();
	if(t) {
	  ns = (struct special *)calloc(1, sizeof(struct special));
	  if(!ns) {
	    perror("calloc()");
	    exit(0);
          }
 	  if(!ls)
	    ls = ns;
	  if(!ys) 
	    ys = ns;
	  else {
	    ys->next = ns;
	    ys = ns;
	  }
	  sprintf(ns->name,"%s",t);
	  ns->next = NULL;
        }
        points.bag--;
	break;
      case 'x':
	save_background(arg,l,ls,lang,randoms,gold);
	ok = 1;
    }
  }
}
  
  
